
CoCoA-5 - Design #1709

Test tut-CoCoLA2

11 Nov 2022 22:21 - John Abbott

Status: Closed Start date: 11 Nov 2022

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: bug Estimated time: 1.01 hour

Target version: CoCoA-5.4.2 Spent time: 1.00 hour

Description

tut-CoCoLa2.cocoa5

prints out the result of LinKer which may vary from call to call.

Change the test so that it does not print out values which may vary from run to run!

[2022-11-11: Recd by email from Ulrich]

History

#1 - 16 Nov 2022 15:42 - John Abbott

I think there are 7 places to revise...

Just search for LinKer and see which ones actually are printed.

#2 - 16 Nov 2022 15:44 - John Abbott

- Assignee set to Anna Maria Bigatti

#3 - 16 Nov 2022 15:46 - Anna Maria Bigatti

- Subject changed from Test tut-cocola2 to Test tut-CoCoLA2

- % Done changed from 0 to 10

#4 - 16 Nov 2022 20:10 - Ulrich von der Ohe

John Abbott wrote:

tut-CoCoLa2.cocoa5

prints out the result of LinKer which may vary from call to call.

Change the test so that it does not print out values which may vary from run to run!

[2022-11-11: Recd by email from Ulrich]

 

I'm not sure this is the same issue I alluded to in my email.

The problem I meant in my email is triggered by line 181 in tut-CoCoLA2.cocoa5:

eigenfactors(A3, z); --> two eigenfactors

This boils down to

f := x^4 - 20*x^2 + 36;

factor(f).factors;

The expected output (as given in tut-CoCoLA2.out) is:

[x^2 -2,  x^2 -18]

I get the reversed order

[x^2 -18,  x^2 -2]

randomly (about every second time two).
Note: I have observed this bug on OpenBSD only, never on a GNU/Linux system.

#5 - 16 Nov 2022 20:35 - Ulrich von der Ohe

PS: Sorry for the late clarification -- I wasn't aware that this was posted here and only saw it by chance.

#6 - 18 Nov 2022 21:54 - Ulrich von der Ohe

Ulrich von der Ohe wrote:

Note: I have observed this bug on OpenBSD only, never on a GNU/Linux system.

 

The problem also appears on other systems.

For example, this is literal input/output from a CoCoA-5 session (running on GNU/Linux, but now I don't think that it matters):

# use R ::= QQ[x];

# f := (x^2 - 2) * (x^2 - 1000);

# f;

x^4 -1002*x^2 +2000

# factor(f);

record[RemainingFactor := 1, factors := [x^2 -2,  x^2 -1000], multiplicities := [1,  1]]

# factor(f);

record[RemainingFactor := 1, factors := [x^2 -1000,  x^2 -2], multiplicities := [1,  1]]

#7 - 30 Nov 2022 19:12 - Anna Maria Bigatti

Reminder for me: check both LinKer and eigenfactors

#8 - 18 Mar 2024 20:59 - John Abbott

- Status changed from New to In Progress

- % Done changed from 10 to 20

Maybe we can change the relevant line(s) to something like:

E1 := eigenfactors(A1, z);

E2 := eigenfactors(A2, z);

E3 := eigenfactors(A3, z);

if not(EqSet(E2, concat(E1,E2))) then println "phi1 & phi2 are not splitting endomorphisms"; endif

What do you think?
#9 - 06 Apr 2024 15:55 - Ulrich von der Ohe

John Abbott wrote:

What do you think?

 

I think it would be preferable to have deterministic output (i.e. literally the same strings). Generally this is much easier to work with. But if that is not

doable then changing the test as you suggest is at least a way to avoid the test failing due to this unexpected presentation of the result. (By the way,

the test still fails with CoCoALib-0.99850 with apparently a 50% chance.)

#10 - 07 Apr 2024 20:41 - John Abbott

Ah, oops!

Since Anna did not object, I have just made the change hinted at in my comment 8 above.  This should avoid the non-deterministic printed result --

Ulrich is right that we should avoid printed values whose printed string form may vary.

#11 - 07 Apr 2024 20:42 - John Abbott

- Status changed from In Progress to Resolved

- % Done changed from 20 to 70

#12 - 12 Apr 2024 19:08 - John Abbott

- % Done changed from 70 to 80

I have just checked-in the changes.  They should be in the next "internal" release.  Hope to resolve #1814 before making an internal release...

#13 - 19 Apr 2024 17:10 - John Abbott

- Status changed from Resolved to Closed

- % Done changed from 80 to 100

- Estimated time set to 1.01 h
